package require dom

# Setup a simple DOM tree

set d [dom::libxml2::create]
set top [dom::libxml2::document createElement $d Top]
set l1 [dom::libxml2::document createElement $top Node1]
set l2 [dom::libxml2::document createElement $top Node2]

set l1_1 [dom::libxml2::document createElement $l1 Node1_1]
set l1_2 [dom::libxml2::document createElement $l1 Node1_2]

set l2_1 [dom::libxml2::document createElement $l2 Node2_1]
set l2_2 [dom::libxml2::document createElement $l2 Node2_2]

# Register normal event listeners

#dom::libxml2::node addEventListener $l1_1 click HandleEvent
#dom::libxml2::node addEventListener $l1 click HandleEvent
#dom::libxml2::node addEventListener $l1_1 mouseup HandleEvent

puts "\n*** add event listener\n"

dom::libxml2::node addEventListener $l1 click HandleEvent -usecapture 1

# Event listener procs

proc HandleEvent evid {
    puts "HandleEvent $evid"
    set currNode [dom::libxml2::event cget $evid -currentNode]
    puts "Event type [dom::libxml2::event cget $evid -type], current node [dom::libxml2::node cget $currNode -nodeName], phase [dom::libxml2::event cget $evid -eventPhase]"
}

puts "\n*** Synthesizing event\n"

set anEvent [dom::libxml2::document createEvent $d click]
dom::libxml2::event initMouseEvent $anEvent click 1 1 {} 0 100 101 10 11 0 0 0 0 0 {}

puts "\n*** Dispatching event\n"

dom::libxml2::node dispatchEvent $l1_1 $anEvent

puts "\n*** Mutation event\n"

proc NewData evid {
    puts "NewData: was \"[dom::libxml2::event cget $evid -prevValue]\" now \"[dom::libxml2::event cget $evid -newValue]\""
}

dom::libxml2::node addEventListener $l1_1 DOMCharacterDataModified NewData -usecapture 1
set t1_1 [dom::libxml2::document createTextNode $l1_1 {Test Value}]
dom::libxml2::node configure $t1_1 -nodeValue {More Bloody Tests!}

